/* PRO-SCAMS "@@(#) delete_lock.c, Rev: 1.2.0.0" */

/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.0                                        12/15/93 */
/*                                                                      */
/* AUTHOR: William C. Brown                                             */
/* VERSION: 1.0 (beta)                                                  */
/* DESCRIPTION: Remove those pesky lock files that undial() doesn't     */
/*		want to remove for me...				*/
/* -------------------------------------------------------------------- */
/* Notes:                                                               */
/*                                                                      */
/*                                                                ----- */

#include <stdio.h>
#include <dirent.h>
#include <termio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/OpenLook.h>
#include <Xol/ScrollingL.h>
#include "uwdialer.h"

void Delete_Lock(int Action)
{
	DIR *dirp;
	struct dirent *dirbuf;
	Boolean CheckForPid(char *, int, int);
	extern int Lock_Pid;

	if((dirp = opendir("/var/spool/locks")) == NULL) {
		(void)DialerError(NONFATAL, CANTOPENLOCKDIR);
		return;
    	}

	while((dirbuf = readdir(dirp)) != NULL) {
        	if(*dirbuf->d_name == '.')
            		continue;

		if(CheckForPid(dirbuf->d_name, Lock_Pid, Action) == True)
			break;
        }
	(void)closedir(dirp);

} /* Remove_Lock */

Boolean CheckForPid(char *file, int pid, int Action)
{
	char Path[BUFSIZ];
	char Buffer[BUFSIZ];
	char ProcessId[128];
	FILE *fp, *fopen();
	void Rewrite_Lock(char *);

	(void)sprintf(Path, "/var/spool/locks/%s", file);
	(void)sprintf(ProcessId, "%d", pid);

	if((fp = fopen(Path, READ)) == NULL) {
		(void)DialerError(NONFATAL, CANTOPENLOCK, Path);
		return(0);
	}

	/* -----					*/
	/* Should only need one line to get the pid out */
	/*					  ----- */

	(void)fgets(Buffer, BUFSIZ, fp);
	(void)fclose(fp);

	if(strstr(Buffer, ProcessId) != NULL) {
		if(Action == REWRITE)
			(void)Rewrite_Lock(Path);
		else
			(void)unlink(Path);
		return(True);
	}

	return(False);
} /* CheckForPid */

void Rewrite_Lock(char *Path)
{
	FILE *fp, *fopen();

	if(chmod(Path, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH) != 0)
		(void)DialerError(NONFATAL, "COULD NOT CHANGE GROUP %d", errno);

	if((fp = fopen(Path, WRITE)) == NULL) {
		(void)DialerError(NONFATAL, REWRITELOCK, Path, errno);
		return;
	}

	(void)fprintf(fp, "%10d\n", getpid()); 
	(void)fclose(fp);
	(void)chmod(Path, S_IRUSR|S_IRGRP|S_IROTH);
	
} /* Rewrite */
