/* PRO-SCAMS "@@(#) logger.c, Rev: 1.1.0.0" */

/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.0                                        12/05/93 */
/*                                                                      */
/* AUTHOR: William C. Brown                                             */
/* VERSION: 1.0 (beta)                                                  */
/* DESCRIPTION: To provide a nice X based dialer interface that works   */
/*              in conjunction with the connection server in SVR4.2.    */
/*                                                                      */
/* -------------------------------------------------------------------- */
/* Notes: Logger function. Put a popup on the screen.			*/
/*                                                                      */
/*                                                                ----- */


#include <stdio.h>
#include <termios.h>
#include <dial.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/Caption.h>
#include <Xol/OpenLook.h>
#include <Xol/Form.h>
#include <Xol/FButtons.h>
#include <Xol/TextField.h>
#include <Xol/StaticText.h>
#include <Xol/ScrollingL.h>

#include "uwdialer.h"

void Set_Logger(Widget, XtPointer, XtPointer);

static String   On_Fields[] = {XtNlabel, XtNselectProc, XtNclientData};
static XtArgVal On_Items[] =
         {(XtArgVal)"Start logger",  (XtArgVal)Set_Logger, (XtArgVal)ON};

static String   Off_Fields[] = {XtNlabel, XtNselectProc, XtNclientData};
static XtArgVal Off_Items[] =
         {(XtArgVal)"Stop logger",  (XtArgVal)Set_Logger, (XtArgVal)OFF};

Widget LoggerTop, LoggerText;

FILE *Logger_fp = NULL;

void Logger_Popup()
{
	int AC = 0;
	Arg args[20];
	Widget Form, Cap1, Bu1, Bu2, Invis;
	extern Widget TopLevel;

	AC = 0;
        XtSetArg(args[AC], XtNtitle, "Logger Popup");   AC++;
        XtSetArg(args[AC], XtNresizeCorners, FALSE);    AC++;
        LoggerTop = XtAppCreateShell("uwdialer", "UWdialer",
                        applicationShellWidgetClass, XtDisplay(TopLevel),
                        args, AC);
	AC = 0;
        Form = XtCreateManagedWidget ("form", formWidgetClass,
                                        LoggerTop, NULL, 0);

	AC = 0;
        XtSetArg(args[AC], XtNlabel, "Log file:");  AC++;
        XtSetArg(args[AC], XtNyRefName, "form");    AC++;
        XtSetArg(args[AC], XtNyOffset, 15);         AC++;
        XtSetArg(args[AC], XtNxOffset, 15);         AC++;
        XtSetArg(args[AC], XtNxAttachRight, TRUE);  AC++;
        XtSetArg(args[AC], XtNxVaryOffset, TRUE);   AC++;
        XtSetArg(args[AC], XtNxAttachOffset, 15);   AC++;
        Cap1 = XtCreateManagedWidget ("cap1", captionWidgetClass,
                                        Form, args, AC);

	AC = 0;
        XtSetArg(args[AC], XtNmaximumSize, 64);    AC++;
        XtSetArg(args[AC], XtNcharsVisible, 64);   AC++;
        LoggerText = XtCreateManagedWidget ("te", textFieldWidgetClass,
                                        Cap1, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNbuttonType, OL_OBLONG_BTN);           AC++;
        XtSetArg(args[AC], XtNitemFields, On_Fields);               AC++;
        XtSetArg(args[AC], XtNnumItemFields, XtNumber(On_Fields));  AC++;
        XtSetArg(args[AC], XtNclientData, LoggerTop);               AC++;
        XtSetArg(args[AC], XtNitems, On_Items);                     AC++;
        XtSetArg(args[AC], XtNlayoutType, OL_FIXEDROWS);            AC++;
        XtSetArg(args[AC], XtNmeasure, 1);                          AC++;
        XtSetArg(args[AC], XtNnumItems, 1);                         AC++;
        XtSetArg(args[AC], XtNyRefWidget, Cap1);                    AC++;
        XtSetArg(args[AC], XtNyOffset, 15);                         AC++;
	XtSetArg(args[AC], XtNyAddHeight, True);		    AC++;
        XtSetArg(args[AC], XtNxRefName, "form");                    AC++;
        XtSetArg(args[AC], XtNxOffset, 50);                         AC++;
        Bu1 = XtCreateManagedWidget ("bu", flatButtonsWidgetClass,
                                     Form, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNbuttonType, OL_OBLONG_BTN);           AC++;
        XtSetArg(args[AC], XtNitemFields, Off_Fields);              AC++;
        XtSetArg(args[AC], XtNnumItemFields, XtNumber(Off_Fields)); AC++;
        XtSetArg(args[AC], XtNclientData, LoggerTop);               AC++;
        XtSetArg(args[AC], XtNitems, Off_Items);                    AC++;
        XtSetArg(args[AC], XtNlayoutType, OL_FIXEDROWS);            AC++;
        XtSetArg(args[AC], XtNmeasure, 1);                          AC++;
        XtSetArg(args[AC], XtNnumItems, 1);                         AC++;
        XtSetArg(args[AC], XtNyRefWidget, Bu1);                     AC++;
        XtSetArg(args[AC], XtNyOffset, 0);                          AC++;
        XtSetArg(args[AC], XtNxRefName, "form");                    AC++;
        XtSetArg(args[AC], XtNxAttachRight, TRUE);                  AC++;
        XtSetArg(args[AC], XtNxVaryOffset, TRUE);                   AC++;
        XtSetArg(args[AC], XtNxAttachOffset, 50);                   AC++;
        Bu2 = XtCreateManagedWidget ("bu", flatButtonsWidgetClass,
                                     Form, args, AC);

	AC = 0;
        XtSetArg(args[AC], XtNstring, "   ");    AC++;
        XtSetArg(args[AC], XtNyRefWidget, Bu2);  AC++;
        XtSetArg(args[AC], XtNyOffset, 0);       AC++;
        XtSetArg(args[AC], XtNyAddHeight, TRUE); AC++;
        Invis = XtCreateManagedWidget ("se", staticTextWidgetClass,
                                        Form, args, AC);

	XtRealizeWidget(LoggerTop);
} /* Logger_Popup */

void Set_Logger(Widget W, XtPointer ClientData, XtPointer CallData)
{
	Arg args[1];
	char *File_Name;
	extern int LOGGER;
	extern int Xtermid;

	LOGGER = (int)ClientData;

	XtSetArg(args[0], XtNstring, &File_Name);
	XtGetValues(LoggerText, args, 1);

	if((int)ClientData == ON) {
		if(strlen(File_Name) == 0) {
			(void)DialerError(NONFATAL, NOLOGGERFILE);
			return;
		}
	}

	if(((int)ClientData == ON) && (Logger_fp != NULL)) {
		(void)DialerError(NONFATAL, LOGALREADYON);
	}

	if((int)ClientData == ON) {
		if((Logger_fp = fopen(File_Name, WRITE)) == NULL) {
			(void)DialerError(NONFATAL, LOGGEROPENFAIL, File_Name);
			return;
		}
	}
	else if((int)ClientData == OFF) {
		if(Logger_fp != NULL)
			(void)fclose(Logger_fp);
		else {
			XtDestroyWidget(LoggerTop);
			return;
		}
		Logger_fp = NULL;
	}

	(void)Update_Display_Logger();
	(void)Call_Enter(NULL, Xtermid, NULL, NULL);

	XtDestroyWidget(LoggerTop);
} /* Set_Logger */
